
(* The type of tokens. *)

type token = 
  | WHILE
  | VOID
  | TURNS
  | TRUE
  | TIMES
  | THIS
  | STRLITERAL of (string)
  | STR
  | SETUP
  | SEMI
  | RPAREN
  | RETURN
  | REMOVE
  | RBRACKET
  | RBRACE
  | PLUS
  | PLACE
  | PASS
  | OR
  | NOT
  | NONE
  | NEQ
  | MOD
  | MINUS
  | LT
  | LPAREN
  | LIST
  | LEQ
  | LBRACKET
  | LBRACE
  | INTLITERAL of (int)
  | INT
  | IN
  | IF
  | ID of (string)
  | GT
  | GROUP
  | GEQ
  | FUNC
  | FOR
  | FALSE
  | EQ
  | EOF
  | END
  | ELSE
  | ELIF
  | DOT
  | DIVIDE
  | CONTINUE
  | COMMA
  | BREAK
  | BOOL
  | ASSIGN
  | ASSERT
  | AND

(* This exception is raised by the monolithic API functions. *)

exception Error

(* The monolithic API. *)

val program: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Ast.program)
